var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import noop from '@jswork/noop';
import classNames from 'classnames';
import React, { Component } from 'react';
import CodeFlask from 'codeflask';
import Prism from 'prismjs';
var CLASS_NAME = 'react-codeflask';
var SUPPORT_LANGUAGES = ['ruby', 'html', 'css', 'javascript', 'java', 'php', 'shell', 'kotlin'];
var ReactCodeflask = /** @class */ (function (_super) {
    __extends(ReactCodeflask, _super);
    function ReactCodeflask() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.root = null;
        _this.jar = null;
        _this.state = { minHeight: 40 };
        _this.addLangs = function () {
            SUPPORT_LANGUAGES.forEach(function (item) {
                _this.jar.addLanguage(item, Prism.languages[item]);
            });
        };
        _this.autoUpdate = function () {
            var onChange = _this.props.onChange;
            onChange({ target: { value: _this.jar.code } });
            _this.setState({ minHeight: _this.compoutedMinHeight });
        };
        return _this;
    }
    Object.defineProperty(ReactCodeflask.prototype, "compoutedMinHeight", {
        get: function () {
            var _a, _b;
            var preHeight = (_a = this.root) === null || _a === void 0 ? void 0 : _a.querySelector('.codeflask__pre');
            var minHeight = preHeight === null || preHeight === void 0 ? void 0 : preHeight.getBoundingClientRect().height;
            var lines = (_b = this.root) === null || _b === void 0 ? void 0 : _b.querySelectorAll('.codeflask__lines .codeflask__lines__line');
            var targetHeight = (lines === null || lines === void 0 ? void 0 : lines.length) == 1 ? minHeight : minHeight + 20;
            return Math.max(targetHeight, 40) || 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ReactCodeflask.prototype, "computedStyle", {
        get: function () {
            var _a = this.props, style = _a.style, height = _a.height;
            return height
                ? __assign(__assign({}, style), { height: height, minHeight: 40 }) : __assign(__assign({}, style), { minHeight: this.compoutedMinHeight });
        },
        enumerable: false,
        configurable: true
    });
    ReactCodeflask.prototype.shouldComponentUpdate = function (inProps) {
        var value = inProps.value;
        if (value !== this.jar.code) {
            this.jar.updateCode(value);
        }
        return true;
    };
    ReactCodeflask.prototype.componentDidMount = function () {
        var _a = this.props, value = _a.value, readOnly = _a.readOnly, options = _a.options;
        // todo: other language  not work.
        var opts = __assign({ language: 'js', readonly: readOnly }, options);
        var editorElem = this.root;
        this.jar = new CodeFlask(editorElem, opts);
        this.addLangs();
        this.jar.updateCode(value);
        this.jar.onUpdate(this.autoUpdate);
    };
    ReactCodeflask.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, value = _a.value, onChange = _a.onChange, height = _a.height, language = _a.language, options = _a.options, props = __rest(_a, ["className", "value", "onChange", "height", "language", "options"]);
        return (React.createElement("div", __assign({ "data-component": CLASS_NAME, className: classNames(CLASS_NAME, className), style: this.computedStyle }, props),
            React.createElement("div", { className: "is-editor", ref: function (root) { return (_this.root = root); } }),
            React.createElement("span", { className: "language-name" }, language)));
    };
    ReactCodeflask.displayName = CLASS_NAME;
    ReactCodeflask.version = '__VERSION__';
    ReactCodeflask.defaultProps = {
        height: 0,
        onChange: noop,
        value: '',
        language: 'javascript',
        readOnly: false,
        options: {
            lineNumbers: true
        }
    };
    return ReactCodeflask;
}(Component));
export default ReactCodeflask;
//# sourceMappingURL=index.js.map